#include <cstdio>
#include <cstdlib>
#include <vector>

extern std::vector<long long> travel(std::vector<long long> A,
        std::vector<int> B, std::vector<int> U, std::vector<int> V, std::vector<int> W);

void my_assert(bool p, int cs)
{
    if(!p)
    {
        if(cs == 1) puts("Wrong input");
        if(cs == 2) puts("Length of array should be N-1");
        exit(0);
    }
}

int main()
{
    int n;
    my_assert(scanf("%d", &n) == 1, 1);
    std::vector<long long> A(n);
    std::vector<int> B(n), U(n - 1), V(n - 1), W(n - 1);
    for(int i = 0; i < n; ++i) my_assert(scanf("%lld", &A[i]) == 1, 1);
    for(int i = 0; i < n; ++i) my_assert(scanf("%d", &B[i]) == 1, 1);
    for(int i = 0; i < n - 1; ++i) my_assert(scanf("%d%d%d", &U[i], &V[i], &W[i]) == 3, 1);
    std::vector<long long> ans = travel(A, B, U, V, W);
    my_assert((int)ans.size() == n - 1, 2);
    printf("secret: XBNN6R0Jnospxlfz11GWxd4ldkzb0I\n");
    for(int i = 0; i < n - 1; ++i) printf("%lld\n", ans[i]);
    printf("secret: XBNN6R0Jnospxlfz11GWxd4ldkzb0I\n");
    return 0;
}
